UPDD Extensions

Help File version 1.0. Dated 1st July 2002

Overview

Not all desired UPDD functionality can be accommodated within the kernel mode driver. Functionality catered for outside of the driver is added as an extension to the driver. It may be that the function can only be achieved via a user mode program or it is just inappropriate for the function to be catered for within the driver.

This help file describes the mechanism by which the UPDD Extensions are implemented and the extensions themselves:

Implementation

Driver functions are either performed by the kernel mode driver or the user mode daemon (background) process. The daemon process handles the System tray menu as well as other processes but it also handles the core UPDD extension functionality.

UPDD extensions may be enabled in the distributed UPDD software or installed via the UPDD Extensions installer.

Utilisation

Once an extension is installed it will be listed in the System Tray menu under the Extension menu entry, as shown below;

A list of installed extensions will be shown when selecting the extension menu entry;

In this example three extensions are installed.

If the extension is shown with a [image] (tick) or [image] (cross) then selecting the extension will toggle the main function implemented by the extension, e.g. Draw will enable or disable desktop drawing. Selecting an extension that does not have a status icon will invoke the extension’s settings dialog.


Installation

The extensions are installed via the UPDD Extensions setup program, setupext.exe, or may be part of the supplied UPDD Setup if the extension has been configured into the build on request.

UPDD Extension setup

Locate and run the setup program setupext.exe.

After the Welcome screen the setup dialog will be displayed showing the available extensions:

This dialog is used to install or uninstall the extensions. Extensions that show zero size indicate that the extension is already part of UPPD otherwise the value shows the amount of disk space required. Ticks against the extensions indicate it is currently installed. Check or uncheck the extensions as required and select Next. Checked extensions will be installed and those not checked will be uninstalled.

At the next, final screen, Select Next to begin extension setup.


Extensions

The following table lists the extensions currently available and shows the UPDD release required and operation system availability:

Name

Description

UPDD

version

OS availability

UPDD Clicks

Additional mouse click mode

3.05.10

Win 9x/98/ME

Win NT/W2K/XP

UPDD Draw

Directly draw on top of active desktop

3.08.00

Win 9x/98/ME

Win NT/W2K/XP

UPDD Play

Associate playback functions with toolbars or pointer device events

3.08.00

Win 9x/98/ME

Win NT/W2K/XP

UPDD Sound

Associate sound with toolbar or mouse click

Future

Win 9x/98/ME

Win NT/W2K/XP

UPDD Video

Video Resolution automatic calibration switch

3.05.04

Win 9x/98/ME

Win NT/W2K/XP


UPDD Clicks

UPDD Clicks – Additional mouse click mode

Overview

This extension introduces a new click emulation mode. When the pointer device is in use the cursor follows the stylus. If the stylus is removed (Pen Up) a left click is generated. However, if the finger is held steady for a period of time a right click is generated. If the stationary finger is in contact with the device for a period less than the threshold a left mouse click will be performed as normal, only if the finger is held stationary for a greater period than the threshold does a right click result. The 'Threshold Mode' (see description below) controls when a right mouse click occurs.

Implementation

On selecting the UPDD Click’s system tray entry

the settings dialog is shown:

Function | Description
Enabled | Indicates the extension is enabled.
Sound | Indicates a sound will be generated at the threshold period.
Threshold | Specifies, in milliseconds, the threshold period.
Threshold Mode | If set, indicates a right click will be generated at the threshold period. If not set, a right click is generated when the stylus is lifted after the threshold period.

Considerations

If this is the only click emulation required UPDD Events should *all* be set to none, as shown below:

UPDD Click installation will automatically set the above settings. Deinstallation will reset them back to the original default settings, Touchdown Left and Touchdown Right.


Draw utility

UPDD Draw – Desktop drawing utility

Overview

This extension is used to draw directly onto the active Windows desktop rather than a snapshot of the desktop at a given time. This has the advantage over normal drawing and annotate programs in that desktop activity is still active and visual whilst drawing is taking place.

The drawing program interfaces directly with the UPDD API and not via mouse emulation. This has the advantage that the mouse is unaffected by the drawing process.

Implementation

Drawing can be invoked from the UPDD system tray extension menu by selecting the UPDD Draw entry. When in drawing mode a tick will be shown against the entry, as shown:

However, drawing can be invoked in other ways and a more detailed description of Draw’s configuration follows.

Draw components

The Draw extension comprises two components; the control program to define draw settings and a background (or daemon) process that handles the desktop drawing process.

Draw daemon process

After installation, either as part of the UPDD setup or the UPDD extension setup, the daemon process will be active and will automatically be invoked at system. The daemon process must be active for drawing to take place. If the daemon process is inactive, select the program manager shortcut as follows:

Draw control program

The draw utility settings are set in the control program. To run the Draw configuration program select the Program Manager shortcut as follows:

This will display the Draw Control Program dialog.

The menu bar indicates the status of the draw daemon process. The daemon process must be active before the drawing process can be activated.

The control program is used to set drawing mode, drawing characteristics and to define UPDD toolbars used to control the drawing process.

Control Panel dialog

Description

Mode

This dialog is used to control the drawing process.

Select mode: Select the drawing mode

Invokes drawing. Using the UPDD pointer device will result in drawing on the desktop in the current pen colour and width.

Pauses drawing process. Current drawing is left on the desktop

Stops the drawing process and clears the screen.

The depressed button indicates the active option.

Erase Drawing: Erases the drawing. Whilst drawing this button can only be activated with the mouse.

Remove Drawing whilst moving windows: On some slower systems desktop drawing performance may be degraded when drawing and this is more noticeable whilst moving windows around the desktop. This setting will temporarily remove the drawing whilst windows are being moved.

Pen

This dialog is used to set the pen characteristics:

Change Colour | Changes the pen colour.
Pen Thickness | Changes the pen thickness. Minimum thickness is 2 pixels.

Toolbars

This dialog is used to set the UPDD (Universal Pointer Device Driver) toolbars used by Draw. A toolbar is an inactive area on the pointer device that disables system cursor movement but can be hooked by an external application, in this case UPDD Draw, such that the external application is informed when the toolbar is selected.

The Disabled checkbox indicates that all draw’s toolbars are disabled. This allows for toolbars to be defined but temporarily disabled if Draw is not in use. This avoids the necessity to redefined and calibrate the toolbar areas each time Draw is to be utilised.

Defining toolbars

Select the ‘Configure’ button to define and calibrate the draw toolbars. The Select Toolbar Buttons dialog will be displayed.

Four toolbars functions are used to control the drawing process:

Draw

Toggles between drawing and stop mode (drawing is cleared).

Clear

Clears the drawing but does not effect current mode.

Pause

Toggles between drawing and pause mode (drawing remains).

Stop

Stops drawing and clears the screen.

Each toolbar function can have two physical toolbars. Select the toolbar to be calibrated. The calibrate toolbar process will be invoked:

Touch the two corners of the toolbar (not the calibrate message box) on the pointer device where the toolbar is to reside.

Repeat this process for the required toolbars.

A toolbar that has been defined will show up in the toolbar dialog as a ‘flattened’ button.

Deleting toolbars

To delete a toolbar, simply click on the ‘flattened’ toolbar button. The toolbar will be removed and the button will be raised.

Toolbar tip

If required, a desktop icon can be placed on the desktop to show the toolbar function. This can be achieved by placing a bitmap on an active web desktop. Simply invoke the desktop properties dialog, web tab. Enable the active desktop and add a .gif file.

This will place the defined image on to the desktop. The image can then be moved as required on the desktop. The position of the image is then calibrated for the required toolbar.

Invoking the drawing functions

By default the drawing daemon process is dormant waiting for a function request. These requests are sent by the Mode dialog of the control program or from one of the toolbars.

In the above example the user has calibrated the draw toolbar in the top left of the screen and the clear draw toolbar in the bottom right of the screen.

Selecting the ‘Draw’ button from the Select Mode dialog or touching the top left of the screen will toggle drawing on/off and clear the screen if previously on.

Selecting the ‘Clear’ button from the Select Mode dialog or touching the bottom right of the screen will clear the drawing.


Playback utility

UPDD Play - Playback facility

Overview

This extension is used to playback mouse clicks, keystrokes, keystroke macros, mouse macros and user written macros when a specific event occurs.

An event is an action that occurs at the pointer device and results in a signal (or trigger) being set or reset. These signals are passed through UPDD to the playback extension, which will perform the action associated with the event.

Playback actions can be associated with either a Toolbar or Data Packet event that, when they occur, will result in an associated playback function being performed.

Implementation

On selecting the UPDD Play’s system tray entry

the settings dialog is shown:

There are three main dialog areas, Toolbar definition, Data definition and general functions, as described below.

General functions

The general options perform the following functions:

Function | Description
OK | Exit configuration dialog.
Cancel | Cancel this session and exit.
Save | Saves play back definitions to a file.
Load | Loads play back definitions from a file.
Import | Imports a Playback scheme from earlier versions of Playback written for UPDD Version 2.x.
Recorder | Invokes the macro recorder to record keystrokes and mouse movements.
Help | Invoke the help file.
Enabled | Indicates if the Playback facility is enabled.

Toolbar functions

The toolbar options perform the following functions:

Function | Description
Edit | Edit an existing toolbar definition.
Delete | Delete toolbar definition.
Calibration | Calibrate toolbar.
New | Define new toolbar definition.

Toolbar definitions

Toolbar’s and their associated playback actions are defined in the toolbar definition dialog, invoked from the Edit or New toolbar function:

Settings

Description

Features

Defines the name of the toolbar and indicates if auto repeat and sticky state are enabled.

Auto repeat repeats the press action as long as the toolbar is selected. The keystroke repeat facility uses the system’s AutoRepeatDelay / AutoRepeatRate. The repeat function is terminated when the next event is received.

Sticky state indicates that the state defined in this toolbar is carried forward to the next toolbar selected. E.g. a toolbar sets the Alt state and is set as sticky - the next toolbar action selected will be with the Alt key set. If the next toolbar selected has ASCII key F defined the sequence generate is ‘Alt F’.

Properties

The properties show the number of rows and columns in the toolbar and can be changed as required. The row and column indicators indicate the toolbar cell associated with this definition. The Top Left and Bottom Right X and Y definitions indicate the extents of the toolbar, based on the X and Y co-ordinates of the pointer device and allows the toolbar size to be fine tuned.

Action’s

Indicates the Press and Release actions associated with the toolbar as described in the Action section.

Data functions

The data options perform the following functions:

Function

Description

Edit

Edit an existing data definition.

Delete

Delete data definition.

New

Define new data definition.

Data definitions

Data structures and their associated playback actions are defined in the Data definition dialog, invoked from the Edit or New data function:

Settings

Description

Features

Defines the name of the data event and indicates if auto repeat is enabled. Auto repeat repeats the action as long as the data packet is received.

Data

This area defines the packet bits that are monitored for a data event. Up to four packet bits can be monitored, allowing for a maximum of 15 combinations. A data event can have two states, set and reset. Set is when the set bit pattern is passed in the data packet and reset is when the reset bit pattern is passed in the data packet. Different playback functions can be associated with each state.

Important note: When an event bit pattern is processed it is only checked against the reset pattern of the last set trigger (if a reset definition exists). Thereafter it is checked against all data set triggers to see if a match is found. This approach allows for the same reset pattern to be used against all set triggers but assumes reset will only be used to reset a playback associated with the last set data trigger.

Action

Indicates the actions associated with the Set and Reset data patterns as described in the Action section.

Playback Actions

This section describes the playback actions that can be associated with a toolbar or data event:

ASCII Key(s)

Indicates a standard ASCII key is played back. The key is defined in the Key value field. E.g. Playback ‘Alt F’:

The Generate Key function can be used to automatically generate the ASCII key. Just click on the function and then select the ASCII key on a real keyboard and hit apply. The key value and modifiers are automatically set.

VK_[key Name]

Indicates that a Virtual keyboard key is played back. The key is shown in the Key identifier. E.g. playback Windows start button from left of keyboard:

The Generate Key function can be used to automatically generate the Virtual key Just click on the function and then select the real ‘virtual’ key (such as Start, Insert, Home, Up arrow etc) on a real keyboard and hit apply. The key value and modifiers are automatically set.

CMD_[Cmd Name]

Indicates that a system command is to be played back. The command is shown in the Key identifier:

The following is a list of available commands:

Command | Description
CMD_Logoff | User logoff from Windows
CMD_Touch | A special function that toggles mouse emulation on/off. Useful for disabling pointer device.

Macro

Indicates a macro is played back.

The Macro fields define the macro to be run. The File shows the name of the Macro file, Name indicates the macro to be run (a macro file can hold many macros) and the Data field holds any data required by a user written macro. See Macro Interface topic for more details.

VK_LBUTTON

VK_RBUTTON

Indicates that the Left or Right mouse button is to be clicked.

The ‘Click action’ section in the dialog is enabled to indicate what click emulation is required;

Command | Description
Down | Click down and hold down
Up | Click up
Single | Complete single click
Double | Complete double click

Sound

A Window’s sound or Sound File can be associated with an action function such that it will be played when the playback occurs. The sound check box indicates if sound is enabled.

The Select button invokes the sound selection dialog:

Playback Examples

Toolbar

In this example a toolbar called WindowsStart has been created to invoke the Program Manager (the equivalent of selecting the [image] button on the desktop) when the toolbar is selected:

Data

In this example a data event called Right Button has been created to produce a right click when the data packet’s event bits EV00, EV01, EV02 and EV03 are all set to 1s:


Playback events

An action that can occur at the pointer device can generate a UPDD event. The playback utility can be configured to monitor for two such events, Toolbar and Data Packet events.

Toolbar Event

A toolbar is an area of the pointer device that is defined such that when it is selected no mouse emulation is performed i.e. cursor does not move and no click emulation is performed. However, a Toolbar event is generated and this event is passed to calling applications. Toolbars are often used to define areas of a touch surface that extends beyond the desktop video. This is often referred to as Touch Surround in that the touch screen will be handling both mouse emulation on the video area and also ‘buttons’ around the video area.

Toolbars can be defined in the UPDD Driver Control Utility (DCU), Calibration tab, toolbar dialog. However, most applications that utilise toolbars, such as the Playback utility, handle the toolbar creation and deletion from within the application.

A toolbar can have any number of rows and columns. All toolbar cells are the same size. Once a toolbar is defined it needs to be calibrated to inform the UPDD driver where the toolbar is located.

Once calibrated, when a toolbar area is touched the cursor does not jump to the point of touch. Instead, the toolbar id, row and column (cell) are reported to any external application that has registered a Toolbar callback.

This is the Toolbar Event.

Data Packet event

When a pointer device is in use a stream of data, known as the data packet, is sent to the hardware port and the data is interpreted by UPDD. This data packet contains various types of information, the standard being X and Y co-ordinates as the stylus moves around and status information, such as a contact indicator. The data is normally sent in a fixed number of bytes, each byte consisting of 8 bits (a bit being a single entity that can be either a 0 or 1). However, other information can be passed in the data packet and this information can, for example, be used to indicate that an action has occurred on the device.

If a controller is passing this additional information, UPDD needs to be informed what bits relate to what type of information. This is achieved at the time the controller is defined to UPDD using mnemonics to describe the function of each bit within a byte. Mnemonics used to define specialist bits are internally labeled DFLT, Evnn (nn = 00 to 08), R, L, Z, HWnnn (nn= 01, 02, 04, 08, 16, 32, 64, 128), which relate to the following usage:

Mnemonioc | Meaning
DFLT | DFLT = 1 while a data stream is present. It goes to 0 when a lift off occurs (either a lift packet is seen or liftoff time is reached).
EVnn | A user defined event bit. Set to 1 as required by the controller.
HWnnn | Relates to port hardware lines, e.g. with a UART, processed directly by UPDD, HW64 = RI, HW32 = DSR and HW16 = CTS.
Z | Z changes when the value of the Z data (for controllers with pressure axis) passes through the "Z Threshold" as defined in the UPDD DCU Settings.
L | Set to 1 when a left click event has occurred. Typically defined in mouse data packets.
R | Set to 1 when a right click event has occurred. Typically defined in mouse data packets.

Example

A data packet has the following 1st Byte defined in UPDD

Byte 1 = 1 LIFT EV00 EV01 EV02 EV03 TY08 TX08

1 is a sync bit, LIFT indicates the stylus contact state bit, EVnn are event bits and TYnn and TXnn are co-ordinate bits.

Whilst the data packets are being received by UPDD any bits that change their state (0>1 or 1>0) are reported to external applications that have registered a UPDD callback via the UPDD API.

This is a Data Packet event.


Macro Interface

This software ships with a keystroke and mouse macro recorder. Key and mouse sequences recorded with this utility may be invoked as a playback action greatly extending the functionality that can be played back. For example a macro could be recorded to type standard text in a document – this text can then be generated when a playback event occurs.

The macro execution mechanism is extensible. A programmer can create an extension DLL to support any action. Further details are available from Touch-Base technical support.

Invoking the Recorder

This utility is invoked from the UPDDPlay configuration dialog by selecting the Recorder option.

The Recorder will be invoked with an Untitled recorder file ready to record macros:

The File menu item allows you to create a New macro file, Open an existing macro file or save the current file. The dialog offers four general options:

Function | Description
Record | Invokes the macro recording procedure.
Play | Plays back the selected macro.
Trigger | Restricts the macro to certain Trigger conditions.
Delete | Deletes the selected macro.

Recording a macro

When the Record function is selected the Macro Properties dialog is shown to define macro properties:

Property | Description
Macro Name | Macro Name as shown in all macro related dialogs
Associate with an application | Indicates that the macro is associated with a specific application (that must be active on the desktop). This method of application association activates an already launched application whilst recording and during play back in the processor. If it cannot be guaranteed that the application will be present then do not associate an application with the macro but launch the application from within the macro e.g. >start > run > notepad.
Start with the Windows key | Indicates that the macro will automatically launch the Windows start menu prior to playing the macro.
Record mouse clicks | By default only keystrokes are recorded. This setting indicates if mouse clicks are to be recorded.
Record mouse motion | In most applications mouse click are all that need to be recorded to perform the required functionality. This setting indicates if mouse motion is recorded as well.

Application association

Macros can be associated with an application such that the playback mechanism will promote an application’s window to the foreground before playing back the macro. This is useful for creating macro sets that are aimed at a particular application. When a macro is being recorded against an application the following dialog is show to select the application (that must be active on the desktop).

A list of active desktop applications is shown. Select the desired application from the list. Indicate in the identification section how this application is best identified when the macro is played back.

Identification | Description
Program | Identified via program name which is shown in the data field
Title prefix | Identified by the title prefix – Enter the prefix text in the data field
Title suffix | Identified by the title suffix – Enter the suffix text in the data field
Whole title | Identified by the whole title in the title bar – Enter the whole title text in the data field
Partial title | Identified by the partial title in the title bar – Enter the partial title text in the space provided

Finally, the Maximize check box is used to indicate if the application’s window is to be maximized when it is brought to the foreground. Mouse motion and clicks are played back relative to the desktop, not the application active window, so it is important the application is activated to the same desktop position. In this situation the safe approach is to maximize the application each time as this will guarantee that it is in the same place.

Note: This method of application association activates an already launched application whilst recording and during play back in the processor. If it cannot be guaranteed that the application will be present then do not associate an application with the macro but launch the application from within the macro e.g. >start > run > notepad.

Recording

Once the macro properties have been defined the recorder is activated and recording. If recording keystrokes only it is useful to know the keyboard shortcuts built into Windows, such as Alt+Esc to switch focus to another application. A comprehensive listing of these keystrokes can be found in the Microsoftâ WindowsÒ keyboard guides available from the MicrosoftÒ web page at http://www.microsoft.com/enable/products/winkeyboard.htm.

A ‘Stop recording’ button is placed on the desktop that should be selected to indicate that the macro is complete.

Selecting Ctrl-Esc on the keyboard can also stop recording and this method is preferable if mouse movements are being recorded.

Playback

Within the recorder

The macro can be played back in the Recorder utility by selecting the Play function. Macros are played back at a constant speed and are not played back at the speed they were recorded. The only delays that might occur are waiting for a window activation switch to be performed.

When playing back macros associated with an application the application will be activated (restored or maximized) before the macro is played back. If the associated application is not available on the desktop the macro will not play.

If the macro is not associated with an application, a list of current desktop applications will be shown to select a ‘test’ application against which to playback the macro:

As a playback action

A macro action is associated with a playback event and invoked when the event occurs.

Defining a Macro Trigger

Note – Triggers can be defined in the recorder but they are not currently supported in UPDD play but will be in a future release. This is documented here to show future functionality that will be available.

Some macros need to be restricted to certain operating system’s locale or releases of a particular application or even the resolution of the desktop video area.

This dialog is used to register a trigger and its associated restrictions:

Field | Description
Trigger | Association to a toolbar cell in the format, ToolbarName;Col,Row e.g. Paint,0,0 – a toolbar Paint could have 3 macros, each with a different trigger. UPDDplay will select the appropriate macro to play based on the triggers.
O/S language | Indicates the associated language. E.g. EN = English (ALL), ENC = English Canadian etc.
EXE date | Restricts the macro to a specific application release, via the .exe time stamp.
Desktop X resolution | Restricts the macro to a specific desktop resolution. E.g 640 = VGA (640 x 480) or 800 = SVGA (800 x 600) etc.

Macro editing

It is hoped that this will be available in a future release and will allow macros to be edited. Unfortunately, in this release, any changes needed in the macro require the entire macro to be re-recorded.


Macro playback limitations

Limitations

The Playback utility background task executes as a user mode program (the same as normal Windows applications). User mode programs do not have any special rights and at certain times may not be able to perform the playback.

An example of this is at Windows NT login, the user mode program will not be active. Another instance is when the Task Manager dialog is shown (after Ctrl, Alt, Del).

If your usage of this utility requires playback functionality during these critical system times it may be possible for us to modify the playback method used such that the UPDD driver is responsible for the playback and, being a kernel mode process, should work in these situations. Contact Touch-Base if you need this capability.


Sound Utility

UPDD Sound – Mouse click sound utility

Overview

This utility allows sound files to be associated with driver mouse click events.

Implementation

On selecting the UPDD Sound system tray entry

the settings dialog is shown:

This control panel allows Window’s sound or sound .wav files to be associated with left and right mouse click actions. Depending on the ‘interrupt sounds’ check box settings, the current sound may be interrupted by the next click event.

The device registered to play .wav files, normally the sound card, plays the files.


UPDD Video

UPDDVideoRes – Video Resolution automatic calibration switch

Overview

A Windows desktop can be easily switched to a different video resolution. When using an absolute pointer device, such as a touch screen, a single calibration can normally cater for all video resolutions as the desktop image in the different resolutions is normally displayed in the same place on the monitor. However, if this is not the case new calibration data will be required every time the video resolution changes. This is also the case when using Light Pens as there is a direct relationship to the desktop resolution and pen calibration.

Implementation

UPDD allows unlimited calibration modes to be defined per device, as shown below in the DCU, Calibration dialogue:

Using this functionality, a calibration mode can be set up for each video resolution likely to be used. The system can then be manually placed into each of the possible video resolutions and calibrated using the associated calibration mode, either via the UPDD System Tray or the DCU, calibrate function, as shown below:

When a light pen is in use this has to be performed if the light pen is to work in different video resolutions.

This extension recognises specific calibration mode names and monitors for video resolution changes and automatically switches calibration to the appropriate mode. The calibration mode name used is based on the height and width of the video mode in the format R<width>x<height>. E.g. switching to video resolution 1024 x 768 will result in the extension switching to calibration mode R1024x768.

If video rotational software is in use the height and width may be inverted and to cater for this situation your would need to define a mode that related to the rotated mode e.g. R768x1024. Remember to calibrate rotated calibration modes when the video is actually rotated.


Maintenance and Support

Any problems encountered with these extensions should be reported to Touch-Base technical support at technical@touch-base.com, quoting your UPDD license SCN number.


Playback examples

Mouse click example

In this example the user does not want the driver to perform mouse left clicks but wants a key area of the pointer device to toggle mouse left click.

Inside the UPDD DCU, Events dialog the Secondary and Primary actions is set to None:

This informs the driver that it is not to perform mouse click emulation, only move the pointer. When the key area is selected on the touch device the data packet will contain a specific event bit setting (in this example the device uses four event bits to offer 1 to 15 different settings). The device sends a zero bit pattern to reset previous set function.

The following settings are used to produce the required effect:

Left mouse click set settings

Left mouse click reset setting

In this example the Left Click trigger has two playbacks assigned. The set bit pattern results in a left click down action. The reset bit pattern performs the left click up.

Virtual Key example

In this example a toolbar is used to invoke the Windows start button.

Define a UPDD toolbar in the DCU, Calibration, Toolbars dialog:

In this example a single toolbar cell is used, hence only one row and column is defined. The toolbar is calibrated where the Start button area is to be held.

The playback setting to invoke the Windows start button is as follows:

When the first cell of toolbar Start Button is selected the virtual key VK_LWIN will be played back.

Macro example

In this example a user is giving a course on Word and wants to print using ‘touchable keys’ in a touchable area surrounding the video display. A toolbar is used to playback the macro Alt F, P, c/r macro.

Using the UPDD DCU a toolbar is defined, as in the above example.

Using the macro recorder interface, record the macro. In this example we have named the macro Word print and stored it in macro file Word.

The follow settings are used to associate the macro with the toolbar: